ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.9 by root, Sun Mar 11 22:36:53 2007 UTC vs.
Revision 1.98 by root, Wed Oct 6 01:48:15 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
14 37
15use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
16use Coro::Event; 43use Coro::EV;
17use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
18use IO::AIO (); 47use IO::AIO ();
19use File::Temp; 48use Digest::MD5 ();
20use Crossfire; 49
21use Coro; 50use Coro 5.12;
22use Coro::AIO; 51use Coro::AIO;
23use POSIX (); 52use Coro::Util;
24use Digest::MD5; 53use Coro::Channel;
54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 59
26sub usage { 60sub usage {
27 warn <<EOF; 61 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 63 [--install-arch path]
40my $VERBOSE = 1; 74my $VERBOSE = 1;
41my $CACHE = 0; 75my $CACHE = 0;
42my $FORCE; 76my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
80
81our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95);
45 96
46END { system "rm", "-rf", $TMPDIR } 97END { system "rm", "-rf", $TMPDIR }
47 98
48Event->signal (signal => "INT", cb => sub { exit 1 }); 99my $s_INT = EV::signal INT => sub { exit 1 };
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 100my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102our %hash;
103
104# here we could try to avoid collisions and reduce chksum size further
105sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hash collision, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122}
50 123
51mkdir $TMPDIR, 0700 124mkdir $TMPDIR, 0700
52 or die "$TMPDIR: $!"; 125 or die "$TMPDIR: $!";
53 126
54sub fork_sub(&) { 127sub fork_sub(&) {
67} 140}
68 141
69sub inst_maps($) { 142sub inst_maps($) {
70 my (undef, $path) = @_; 143 my (undef, $path) = @_;
71 144
72 print "installing '$path' to '$DATADIR/maps'\n\n"; 145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 146
74 if (!-f "$path/regions") { 147 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 149 exit 1 unless $FORCE;
77 } 150 }
78 151
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
156 and die "map installation failed.\n";
157
158 print "maps installed successfully.\n";
80} 159}
81 160
161our @WALL_SUFFIX = qw(⬤ ╹ ╺ ┗ ╻ ┃ ┏ ┣ ╸ ┛ ━ ┻ ┓ ┫ ┳ ╋);
162
163# used to create crude text glyphs for text-based clients
164sub autoglyph {
165 my ($stem, $face) = @_;
166
167 if ($stem =~ /^wall\/|Nimwall/) {
168 return $WALL_SUFFIX[hex $1]
169 if $stem =~ /(_[0-9A-F]).x11/;
170
171 "█"
172
173 } elsif ($stem =~ /^traps\//) {
174 "☠"
175
176 } elsif ($stem =~ /^armour\//) {
177 "☗"
178
179 } elsif ($stem =~ /^weapon\//) {
180 "†"
181
182 } elsif ($stem =~ /^readable\//) {
183 "✉"
184
185 } elsif ($stem =~ /^river\//) {
186 "⌇"
187
188 } elsif ($stem =~ /^floor\/|^ground\/|Nimfloor/) {
189 "."
190
191 } elsif ($stem =~ /^player\//) {
192 "\@"
193
194 } elsif ($stem =~ /^(?:monster|misc|class|connect|gods|indoor|inorganic|mining|music|skills).*\/(.)/) {
195 $1
196
197 } else {
198 substr $stem, 0, 1
199 }
200}
201
82{ 202{
83 our %PNG32; 203 our %ANIMINFO;
84 our %FACEINFO; 204 our %FACEINFO;
205 our %RESOURCE;
85 our @ARC; 206 our @ARC;
207 our %ARC;
208 our $TRS;
86 our $NFILE; 209 our $NFILE;
87 our %ANIM; 210 our $PATH;
88 211
89 our (@png, @trs, @arc); # files we are interested in 212 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
90 213
214 our $c_arc = new Coro::Channel;
215 our $c_trs = new Coro::Channel;
216 our $c_res = new Coro::Channel;
217
218 our @c_png;
219
91 sub commit_png { 220 sub commit_png($$$$) {
92 my ($name, $data) = @_; 221 my ($stem, $name, $data, $T) = @_;
93 222
94 $PNG32{$name} = $data; 223 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
95 $FACEINFO{$name} ||= {}; 224 $FACEINFO{$name}{"data$T"} = $data;
96 } 225 }
97 226
98 sub process_png { 227 sub process_png {
99 while (@png) { 228 while (@c_png) {
100 my $path = pop @png; 229 my ($path, $delete) = @{pop @c_png};
101 230
102 my $png; 231 my $png;
103 aio_lstat $path; 232 aio_lstat $path;
104 my ($size, $mtime) = (stat _)[7,9]; 233 my ($size, $mtime) = (stat _)[7,9];
105 234
106 if (0 > aio_load $path, $png) { 235 if (0 > aio_load $path, $png) {
107 warn "$path: $!, skipping.\n"; 236 warn "$path: $!, skipping.\n";
108 next; 237 next;
109 } 238 }
110 239
240 my $stem = $path;
241 my $T;
242
243 if ($stem =~ s/\.32x32\.png~?$//) {
244 $T = 32;
245 } elsif ($stem =~ s/\.64x64\.png~?$//) {
246 $T = 64;
247 } else {
248 warn "$path: weird filename, skipping.\n";
249 next;
250 }
251
111 # quickly extract width and height of the (necessarily PNG) image 252 # quickly extract width and height of the (necessarily PNG) image
112 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 253 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
113 warn "$path: not a recongized png file, skipping.\n"; 254 warn "$path: not a recognized png file, skipping.\n";
114 next; 255 next;
115 } 256 }
116 257
117 my ($w, $h) = unpack "NN", $1; 258 my ($w, $h) = unpack "NN", $1;
118
119 (my $face = $path) =~ s/^.*\///;
120 my $T = 32;
121
122 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
123 warn "$path: weird filename, skipping.\n";
124 next;
125 }
126 259
127 if ($w < $T || $h < $T) { 260 if ($w < $T || $h < $T) {
128 warn "$path: too small ($w $h), skipping.\n"; 261 warn "$path: too small ($w $h), skipping.\n";
129 next; 262 next;
130 } 263 }
132 if ($w % $T || $h % $T) { 265 if ($w % $T || $h % $T) {
133 warn "$path: weird png size ($w $h), skipping.\n"; 266 warn "$path: weird png size ($w $h), skipping.\n";
134 next; 267 next;
135 } 268 }
136 269
270 (my $base = $stem) =~ s/^.*\///;
271
272 my $fi = $FACEINFO{$base};
273 unless ($fi) {
274 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
275 #next;
276 }
277
278 my $arc = $fi->{arc} || { };
279
280 unless ($path =~ /~$/) {
281 # possibly enlarge
282 if (0 > aio_stat "$stem.64x64.png") {
283 my $other = "$stem.64x64.png~";
284
285 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
286 fork_sub {
287 my $CROP;
288 my $SRC = "png:\Q$path\E";
289
290 my $is_floor = $arc->{is_floor};
291 my $is_wall = 0;
292
293 my ($wall_pfx, $wall_dir, $wall_sfx);
294
295 if (
296 !$is_floor
297 && !$arc->{alive}
298 && $arc->{move_block} eq "all"
299 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
300 ) {
301 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
302
303 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
304 $is_wall = 1;
305 }
306 }
307
308 if ($is_wall || $is_floor) {
309 # add a 4px border and add other images around it
310 $CROP = "-shave 8x8 +repage";
311
312 $w += 8;
313 $h += 8;
314
315 $SRC = "-size ${w}x${h} xc:transparent";
316 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
317
318 # 8 surrounding images
319 for (
320 # x y b r0 r1
321 [-1, -1, 0, 6],
322 [ 0, -1, 1, 10, 14],
323 [+1, -1, 0, 12],
324
325 [-1, 0, 8, 5, 7],
326 #
327 [+1, 0, 2, 5, 13],
328
329 [-1, +1, 0, 3],
330 [ 0, +1, 4, 10, 11],
331 [+1, +1, 0, 9],
332 ) {
333 my ($x, $y, $d, $r0, $r1) = @$_;
334
335 my $tile = $is_floor ? $path
336 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
337 : die;
338
339 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
340 "\Q$tile",
341 $x * ($w - 8) + 4,
342 $y * ($h - 8) + 4;
343 }
344 }
345
346 system "convert -depth 8 $SRC rgba:-"
347 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
348 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
349 and die "convert/cfhq2xa pipeline error: status $? ($!)";
350 system $OPTIPNG, "-i0", "-q", "$other~";
351 die "$other~ has zero size, aborting." unless -s "$other~";
352 rename "$other~", $other;
353 };
354 }
355
356 push @c_png, [$other, !$CACHE];
357 }
358
359 # possibly scale down
360 if (0 > aio_stat "$stem.32x32.png") {
361 my $other = "$stem.32x32.png~";
362
363 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
364 fork_sub {
365 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
366 system $OPTIPNG, "-i0", "-q", "$other~";
367
368 # reduce smoothfaces >10000 bytes
369 # obsolete, no longer required
370 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
371 my $ncolor = 256;
372 while () {
373 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
374 system $OPTIPNG, "-i0", "-q", "$other~~";
375 last if 10000 > -s "$other~~";
376 $ncolor = int $ncolor * 0.9;
377 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
378 }
379
380 printf "reduced %s from %d to %d bytes using %d colours.\n",
381 $other, -s "$other~", -s "$other~~", $ncolor
382 if $VERBOSE >= 2;
383 rename "$other~~", "$other~";
384 }
385
386 die "$other~ has zero size, aborting." unless -s "$other~";
387 rename "$other~", $other;
388 };
389 }
390
391 #warn "scaled down $path to $other\n";#d#
392 push @c_png, [$other, !$CACHE];
393 }
394 }
395
396 (my $face = $stem) =~ s/^.*\///;
397
398 # split all bigfaces, but avoid smoothfaces (*_S)
137 if (($w > $T || $h > $T) && $face !~ /_S\./) { 399 if (($w > $T || $h > $T) && $face !~ /_S\./) {
138 # split 400 # split
139 my @tile; 401 my @tile;
140 for my $x (0 .. (int $w / $T) - 1) { 402 for my $x (0 .. (int $w / $T) - 1) {
141 for my $y (0 .. (int $h / $T) - 1) { 403 for my $y (0 .. (int $h / $T) - 1) {
155 ( 417 (
156 "(", 418 "(",
157 "+clone", 419 "+clone",
158 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 420 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
159 "+repage", 421 "+repage",
422 -quality => "00",
160 -write => "png:$_->[2]~", 423 -write => "png32:$_->[2]~",
161 "+delete", 424 "+delete",
162 ")", 425 ")",
163 ) 426 )
164 } @todo), 427 } @todo),
165 "null:"; 428 "null:";
169 close $convert; 432 close $convert;
170 433
171 # pass 2, optimise, and rename 434 # pass 2, optimise, and rename
172 for (@todo) { 435 for (@todo) {
173 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 436 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
437 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
174 rename "$_->[2]~", $_->[2]; 438 rename "$_->[2]~", $_->[2];
175 } 439 }
176 }; 440 };
177 } 441 }
178 442
182 446
183 if (0 > aio_load $file, $tile) { 447 if (0 > aio_load $file, $tile) {
184 die "$path: unable to read tile +$x+$y, aborting.\n"; 448 die "$path: unable to read tile +$x+$y, aborting.\n";
185 } 449 }
186 IO::AIO::aio_unlink $file unless $CACHE; 450 IO::AIO::aio_unlink $file unless $CACHE;
187 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 451 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
188 } 452 }
189 } else { 453 } else {
190 # use as-is (either small, use smooth) 454 # use as-is (either small, use smooth)
191 commit_png $face, $png; 455 commit_png $stem, $face, $png, $T;
192 } 456 }
457
458 aio_unlink $path if $delete;
193 } 459 }
194 } 460 }
195 461
196 sub process_arc { 462 sub process_arc {
197 while (@arc) { 463 while (my $job = $c_arc->get) {
198 my ($dir, $file) = @{pop @arc}; 464 my ($dir, $file) = @$job;
199 465
200 my $arc; 466 my $arc;
201 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 467 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
202 468
203 my $arc = read_arch "$dir/$file"; 469 my $arc = read_arch "$dir/$file";
204 for my $o (values %$arc) { 470 for my $o (values %$arc) {
205 push @ARC, $o; 471 push @ARC, $o;
472 for (my $m = $o; $m; $m = $m->{more}) {
473 $ARC{$m->{_name}} = $m;
474 }
475
476 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
206 477
207 my $visibility = delete $o->{visibility}; 478 my $visibility = delete $o->{visibility};
208 my $magicmap = delete $o->{magicmap}; 479 my $magicmap = delete $o->{magicmap};
480 my $glyph = delete $o->{glyph};
209 481
210 # find upper left corner :/ 482 # find upper left corner :/
211 # omg, this is sooo broken 483 # omg, this is sooo broken
212 my ($dx, $dy); 484 my ($dx, $dy);
213 for (my $o = $o; $o; $o = $o->{more}) { 485 for (my $o = $o; $o; $o = $o->{more}) {
219 my $x = $o->{x} - $dx; 491 my $x = $o->{x} - $dx;
220 my $y = $o->{y} - $dy; 492 my $y = $o->{y} - $dy;
221 493
222 my $ext = $x|$y ? "+$x+$y" : ""; 494 my $ext = $x|$y ? "+$x+$y" : "";
223 495
224 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 496 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
225 497
226 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 498 $visibility = delete $o->{visibility} if exists $o->{visibility};
227 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 499 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
500 $glyph = delete $o->{glyph} if exists $o->{glyph};
228 501
229 my $anim = delete $o->{anim}; 502 my $anim = delete $o->{anim};
230 503
231 if ($anim) { 504 if ($anim) {
505 # possibly add $ext to the animation name to avoid
506 # the need to specify archnames for all parts
507 # of a multipart archetype.
232 $o->{animation} = "$o->{_name}"; 508 $o->{animation} = "$o->{_name}";
509 my $facings = 1;
510 my @frames;
233 511
234 for (@$anim) { 512 for (@$anim) {
235 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 513 if (/^facings\s+(\d+)/) {
514 $facings = $1*1;
515 } elsif (/^blank.x11$|^empty.x11$/) {
516 push @frames, $_;
517 } else {
518 push @frames, "$_$ext";
519 }
236 } 520 }
237 521
238 $ANIM{"$o->{_name}$ext"} = 522 $ANIMINFO{$o->{animation}} = {
239 join "", map "$_\n", 523 facings => $facings,
240 "anim $o->{_name}", 524 frames => \@frames,
241 @$anim, 525 };
242 "mina";
243 } 526 }
244 527
245 for my $face ($o->{face} || (), @{$anim || []}) { 528 for ($o->{face} || (), @{$anim || []}) {
246 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 529 next if /^facings\s/;
247 530
531 my $face = $_;
532 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
533
248 my $info = $FACEINFO{$face} ||= {}; 534 my $info = $FACEINFO{$face} ||= { };
535 $info->{arc} = $o;
536
537 next if $face =~ /^blank.x11$|^empty.x11$/;
249 538
250 $info->{visibility} = $visibility if defined $visibility; 539 $info->{visibility} = $visibility if defined $visibility;
251 $info->{magicmap} = $magicmap if defined $magicmap; 540 $info->{magicmap} = $magicmap if defined $magicmap;
541 $info->{glyph} = $glyph if defined $glyph;
252 } 542 }
543
544 if (my $smooth = delete $o->{smoothface}) {
545 my %kv = split /\s+/, $smooth;
546 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
547 while (my ($face, $smooth) = each %kv) {
548 $FACEINFO{$smooth}{arc} = $o;
549
550 $FACEINFO{$face}{smooth} = $smooth;
551 $FACEINFO{$face}{smoothlevel} = $level;
552 }
553 }
253 } 554 }
254 } 555 }
255 } 556 }
256 } 557 }
257 558
258 sub process_trs { 559 sub process_trs {
259 while (@trs) { 560 while (my $job = $c_trs->get) {
260 my ($dir, $file) = @{pop @trs}; 561 my ($dir, $file) = @$job;
562 my $path = "$dir/$file";
563
564 my $trs;
565 if (0 > aio_load $path, $trs) {
566 warn "$path: $!, skipping.\n";
567 next;
568 }
569
570 $TRS .= $trs;
571 }
572 }
573
574 my %FILECACHE;
575
576 sub load_cached($;$) {
577 unless (exists $FILECACHE{$_[0]}) {
578 my $data;
579 if (0 < aio_load $_[0], $data) {
580 if ($_[1]) {
581 $data = eval { $_[1]->($data) };
582 warn "$_[0]: $@" if $@;
583 }
584 }
585
586 $FILECACHE{$_[0]} = $data;
587 }
588
589 $FILECACHE{$_[0]}
590 }
591
592 sub process_res {
593 while (my $job = $c_res->get) {
594 my ($dir, $file, $type) = @$job;
595
596 my $data;
597 aio_load "$dir/$file", $data;
598
599 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
600
601 utf8::decode $dir;
602 utf8::decode $file;
603
604 # a meta file for resources is now mandatory
605 unless (exists $meta->{$file}) {
606 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
607 next;
608 }
609
610 $meta = {
611 %{ $meta->{"" } || {} },
612 %{ $meta->{$file} || {} },
613 };
614
615 if ($meta->{license} =~ s/^#//) {
616 $meta->{license} = ({
617 "pd" => "Public Domain",
618 "gpl" => "GNU General Public License, version 3.0 or any later",
619 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
620 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
621 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
622 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
623 })->{$meta->{license}}
624 || warn "$dir/$file: license tag '$meta->{license}' not found.";
625 }
626
627 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
628 ($meta->{author} = $1) =~ s/_/ /g;
629 }
630
631 $file =~ s/\.res$//;
632 $file =~ s/\.(ogg|wav|jpg|png)$//;
633
634 substr $dir, 0, 1 + length $PATH, "";
635
636 if (my $filter = $meta->{cfutil_filter}) {
637 if ($filter eq "yaml2json") {
638 $data = JSON::XS::encode_json YAML::XS::Load $data;
639 } elsif ($filter eq "json2json") {
640 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
641 } elsif ($filter eq "perl2json") {
642 $data = eval $data; die if $@;
643 $data = JSON::XS::encode_json $data;
644 } else {
645 warn "$dir/$file: unknown filter $filter, skipping\n";
646 }
647 }
648
649 $RESOURCE{"$dir/$file"} = {
650 type => (exists $meta->{type} ? delete $meta->{type} : $type),
651 data => $data,
652 %$meta ? (meta => $meta) : (),
653 };
261 } 654 }
262 } 655 }
263 656
264 sub find_files; 657 sub find_files;
265 sub find_files { 658 sub find_files {
268 IO::AIO::aioreq_pri 4; 661 IO::AIO::aioreq_pri 4;
269 IO::AIO::aio_scandir $path, 4, sub { 662 IO::AIO::aio_scandir $path, 4, sub {
270 my ($dirs, $nondirs) = @_; 663 my ($dirs, $nondirs) = @_;
271 664
272 find_files "$path/$_" 665 find_files "$path/$_"
273 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 666 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
667
668 my $dir = $path;
669 substr $dir, 0, 1 + length $PATH, "";
274 670
275 for my $file (@$nondirs) { 671 for my $file (@$nondirs) {
672 if ($dir =~ /^music(?:\/|$)/) {
673 $c_res->put ([$path, $file, 3]) # FT_MUSIC
674 if $file =~ /\.(ogg)$/;
675
676 } elsif ($dir =~ /^sound(?:\/|$)/) {
677 $c_res->put ([$path, $file, 5]) # FT_SOUND
678 if $file =~ /\.(wav|ogg)$/;
679
680 } elsif ($dir =~ /^res(?:\/|$)/) {
681 if ($file =~ /\.(jpg|png)$/) {
682 $c_res->put ([$path, $file, 0]) # FT_FACE
683 } elsif ($file =~ /\.(res)$/) {
684 $c_res->put ([$path, $file, 6]) # FT_RSRC
685 } else {
686 $c_res->put ([$path, $file, undef]);
687 }
688
276 if ($file =~ /\.png$/) { 689 } elsif ($file =~ /\.png$/) {
277 push @png, "$path/$file"; 690 push @c_png, ["$path/$file", 0];
691
278 } elsif ($file =~ /\.trs$/) { 692 } elsif ($file =~ /\.trs$/) {
279 push @trs, [$path, $file]; 693 $c_trs->put ([$path, $file]);
694
280 } elsif ($file =~ /\.arc$/) { 695 } elsif ($file =~ /\.arc$/) {
281 push @arc, [$path, $file]; 696 $c_arc->put ([$path, $file]);
697
282 } else { 698 } else {
283 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 699 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
284 } 700 }
285 } 701 }
286 }; 702 };
703 }
704
705 sub generate_plurals {
706# use Lingua::EN::Inflect ();
707# Lingua::EN::Inflect::classical;
708# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
709# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
710#
711# for my $a (@ARC) {
712# my $name = $a->{name} || $a->{_name};
713#
714# next unless $a->{name_pl};
715# next if $a->{invisible};
716# next if $a->{is_floor};
717# next if $a->{no_pick};
718#
719# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
720# my $pl = $test =~ /^(?:eq|p:.)$/
721# ? $name
722# : Lingua::EN::Inflect::PL $name;
723#
724# if ($pl ne $a->{name_pl}) {
725# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
726# }
727# }
287 } 728 }
288 729
289 sub inst_arch($) { 730 sub inst_arch($) {
290 my (undef, $path) = @_; 731 my (undef, $path) = @_;
291 732
733 $PATH = $path;
734
735 print "\n",
292 print "installing '$path' to '$DATADIR'\n\n"; 736 "Installing '$path' to '$DATADIR'\n",
737 "\n",
738 "This can take a long time if you run this\n",
739 "for the first time or do not use --cache.\n",
740 "\n",
741 "Unless you run verbosely, all following warning\n",
742 "or error messages indicate serious problems.\n",
743 "\n";
293 744
294 if (!-d "$path/treasures") { 745 if (!-d "$path/treasures") {
295 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 746 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
296 exit 1 unless $FORCE; 747 exit 1 unless $FORCE;
297 } 748 }
298 749
750 print "scanning files...\n" if $VERBOSE;
751
299 find_files $path; 752 find_files $path;
753
754 my @a_arc = map +(async \&process_arc), 1..2;
755 my @a_res = map +(async \&process_res), 1..2;
756 my @a_trs = map +(async \&process_trs), 1..2;
757
300 IO::AIO::flush; 758 IO::AIO::flush;
301 759
302 $_->join for ( 760 $c_res->shutdown;
303 (async \&process_png), (async \&process_png), 761 $c_arc->shutdown;
304 (async \&process_trs), (async \&process_trs), 762 $c_trs->shutdown;
305 (async \&process_arc), (async \&process_arc),
306 );
307 763
764 print "start file scan, arc, res processing...\n" if $VERBOSE;
765
766 $_->join for @a_arc; # need to parse all archetypes before png processing
767
768 print "end arc, start png processing...\n" if $VERBOSE;
769
770 # eight png crunchers work fine for my 4x smp machine
771 my @a_png = map +(async \&process_png), 1..8;
772
773 $_->join for (@a_trs, @a_res, @a_png);
774
775 print "scanning done, processing results...\n" if $VERBOSE;
308 { 776 {
309 open my $fh, ">:utf8", "$DATADIR/animations~" 777 # remove path prefix from editor_folder
310 or die "$DATADIR/animations~: $!"; 778 $_->{editor_folder} =~ /^\x00/
311 print $fh join "", map $ANIM{$_}, sort keys %ANIM 779 and substr $_->{editor_folder}, 0, 2 + length $path, ""
780 for values %ARC;
781
782 print "resolving inheritance tree...\n" if $VERBOSE;
783 # resolve inherit
784 while () {
785 my $progress;
786 my $loop;
787
788 for my $o (values %ARC) {
789 for my $other (split /,/, $o->{inherit}) {
790 if (my $s = $ARC{$other}) {
791 if ($s->{inherit}) {
792 $loop = $s;
793 } else {
794 delete $o->{inherit};
795 my %s = %$s;
796 delete @s{qw(_name more name name_pl)};
797 %$o = ( %s, %$o );
798 ++$progress;
799 }
800 } else {
801 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
802 delete $ARC{$o->{_name}};
803 }
804 }
805 }
806
807 unless ($progress) {
808 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
809 if $loop;
810
811 last;
812 }
312 } 813 }
313 814
314 { 815 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
816 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
817
818 print "generating plurals...\n" if $VERBOSE;
819 generate_plurals;
820
821 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
315 open my $fh, ">:utf8", "$DATADIR/archetypes~" 822 open my $fh, ">:utf8", "$DATADIR/archetypes~"
316 or die "$DATADIR/archetypes~: $!"; 823 or die "$DATADIR/archetypes~: $!";
317 print $fh Crossfire::archlist_to_string \@ARC; 824 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
318 } 825 }
319 826
320 { 827 {
828 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
829 open my $fh, ">:utf8", "$DATADIR/treasures~"
830 or die "$DATADIR/treasures~: $!";
831 print $fh $TRS;
832 }
833
834 {
835 print "processing facedata...\n" if $VERBOSE;
321 while (my ($k, $v) = each %FACEINFO) { 836 while (my ($k, $v) = each %FACEINFO) {
322 $v->{data32} ||= delete $PNG32{$k}; 837 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
838 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
839
840 make_hash $k, $v->{data32}, $v->{hash32};
841 make_hash $k, $v->{data64}, $v->{hash64};
842
843 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
844 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
845
846 if (my $magicmap = $v->{magicmap}) {
847 $magicmap =~ y/A-Z_\-/a-z/d;
848 $v->{magicmap} = $COLOR{$magicmap};
323 } 849 }
324 850
851 my $stem = delete $v->{stem};
852 $v->{glyph} //= autoglyph $stem, $v;
853 utf8::encode $v->{glyph};
854 $v->{glyph} = (chr $v->{magicmap}) . $v->{glyph};
855
856 delete $v->{arc};
857 }
858
859 print "processing resources...\n" if $VERBOSE;
860 my $enc = JSON::XS->new->utf8->canonical->relaxed;
325 while (my ($k, $v) = each %FACEINFO) { 861 while (my ($k, $v) = each %RESOURCE) {
326 length $v->{data32} or warn "$k: face has no png32. this will crash the server.\n";
327 862
328 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 863 if ($v->{meta} && $v->{meta}{datadir}) {
864 delete $RESOURCE{$k};
865
866 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
867
868 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
869 open my $fh, ">:raw", "$DATADIR/$k~"
870 or die "$DATADIR/$k~: $!";
871 syswrite $fh, $v->{data};
872 push @COMMIT, $k;
873
874 } else {
875 if ($v->{type} & 1) {
876 # prepend meta info
877
878 my $meta = $enc->encode ({
879 name => $k,
880 %{ $v->{meta} || {} },
881 });
882
883 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
884 }
885
886 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
329 } 887 }
888 }
330 889
890 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
891 scalar keys %FACEINFO,
892 scalar keys %ANIMINFO,
893 scalar keys %RESOURCE
894 if $VERBOSE;
895
331 open my $fh, ">:perlio", "$DATADIR/faces~" 896 open my $fh, ">:perlio", "$DATADIR/facedata~"
332 or die "$DATADIR/faces~: $!"; 897 or die "$DATADIR/facedata~: $!";
333 898
334 print $fh Storable::nfreeze \%FACEINFO; 899 print $fh nfreeze {
335 900 version => 2,
336 #use PApp::Util; warn PApp::Util::dumpval \%FACEINFO; 901 faceinfo => \%FACEINFO,
902 animinfo => \%ANIMINFO,
903 resource => \%RESOURCE,
337 } 904 };
338 905
339 for (qw(archetypes faces animations)) { 906 }
907
908 print "committing files...\n" if $VERBOSE;
909
910 for (qw(archetypes facedata treasures), @COMMIT) {
340 chmod 0644, "$DATADIR/$_~"; 911 chmod 0644, "$DATADIR/$_~";
341 rename "$DATADIR/$_~", "$DATADIR/$_"; 912 rename "$DATADIR/$_~", "$DATADIR/$_"
913 or die "$DATADIR/$_: $!";
342 } 914 }
343 915
344 die "--install-arch not fully implemented\n"; 916 print "archetype data installed successfully.\n";
345 } 917 }
346} 918}
347 919
348Getopt::Long::Configure ("bundling", "no_ignore_case"); 920Getopt::Long::Configure ("bundling", "no_ignore_case");
349GetOptions ( 921GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines